/*
 * Copyright 2014 Canonical Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "manager.h"
#include "upload_manager_factory.h"

namespace Lomiri {

using namespace Transfers;

namespace UploadManager {

namespace Daemon {

UploadManagerFactory::UploadManagerFactory(QObject *parent)
    : ManagerFactory(parent) {
}

BaseManager*
UploadManagerFactory::createManager(System::Application* app,
                                    System::DBusConnection* connection,
                                    bool stoppable,
                                    QObject *parent) {
    return new UploadManager(app, connection, stoppable, parent);
}

}  // Daemon

}  // UploadManager

}  // Lomiri
